%%
%% killtree, a simple tool for killing a process and all its subprocesses
%%

functor

import
   Application System

   Process
   at 'x-ozlib://mathweb/share/Process.ozf'
   
define
   AppName = 'killtree'
   
   Spec = record(debug(single char:&d type:bool default:false)
                )
   Args
   try
      Args={Application.getArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end
   
   {ForAll {Map Args.1 StringToInt}
    proc {$ P}
       Ps = {Process.getTree P}
    in
       if Args.debug then
          {System.printInfo "kill -9"}
          {ForAll Ps proc {$ P} {System.printInfo " "#P} end}
          {System.showInfo ''}
       end
       {Process.sigKill Ps}
    end}
   
   {Application.exit 0}
end
