%%
%% Base64 encoder/decoder
%%

functor

import
   Open(text file)
   OS(system tmpnam unlink)
   
   File at 'x-ozlib://mathweb/share/File.ozf'

export
   encode: Encode % fun {$ VS} --> VS
   decode: Decode % fun {$ VS} --> VS
   
define

   class Textfile from Open.text Open.file end
   
   proc {Encode VS ?EncodedVS}
      Tmp1 = {OS.tmpnam}
      Tmp2 = {OS.tmpnam}
      E
   in
      {File.saveVS VS Tmp1}
      {OS.system "uuencode --base64 "#Tmp1#" '' >"#Tmp2 ?E}
      if E\=0 then
         raise uuencode(E) end
      end
      local
         F = {New Textfile init(name:Tmp2)}
         fun {ReadLines}
            case {F getS($)} of false then raise uuencode(unexpectedEOF) end
            [] "====" then nil
            [] Line then Line#'\n'#{ReadLines}
            end
         end
      in
         {F getS(_)}
         EncodedVS = {ReadLines}
         {F close}
      end
      {OS.unlink Tmp1}
      {OS.unlink Tmp2}
   end
   
   proc {Decode EncodedVS ?VS}
      Tmp1 = {OS.tmpnam}
      Tmp2 = {OS.tmpnam}
      E
   in
      {File.saveVS "begin-base64 644 "#Tmp2#"\n"#EncodedVS#"\n====" Tmp1}
      {OS.system "uudecode "#Tmp1 ?E}
      if E\=0 then
         raise uudecode(E) end
      end
      VS = {File.loadVS Tmp2}
      {OS.unlink Tmp1}
      {OS.unlink Tmp2}
   end

end
