%%%
%%% generation of random numbers
%%%

functor

import
   OS(srand randLimits rand)

export
   get: GetRand
   
define

   {OS.srand 0}

   MIN MAX
   {OS.randLimits ?MIN ?MAX}

   VALUES = MAX - MIN + 1

   FACTOR = {Log 10.0} / {Log {Int.toFloat VALUES}}

   fun {DoGetRand Acc N}
      if N=<0 then Acc
      else {DoGetRand Acc*VALUES+{OS.rand}-MIN N-1} end
   end

   fun {GetRand MinDigits}
      {Pow 10 MinDigits} +
      {DoGetRand 0 {Float.toInt {Float.ceil {Int.toFloat MinDigits} * FACTOR}}}
   end 
end
