%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Broker.oz ; This file is part of the MathWeb system
%
%   major updates: 18.10.2000
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
functor   %% file utilities

import
   OS(unlink) 
   File            at 'x-ozlib://mathweb/share/File.ozf'
   Resolve 

export
   loadVS: LoadVS

define
   proc {LoadVS Url ?VS}
      case {Resolve.localize Url}
      of old(F) then VS = {File.loadVS F} 
      [] new(F) then VS = {File.loadVS F} {OS.unlink F}
      end
   end      
end




